{ Puzzle 15 v. 2.0 (c) 1999, 2000 Dmitry Konnov
  Tested under Win95, Win98, WinNT 4.0 SP1
}

{$APPTYPE GUI}
{$M 16384,131072}
{$Q-,R-,T-,I-,X+}
program Puzzle15;
uses Windows,Messages,ShellAPI,ToolTips;

{$I PUZZLE15.RI}
{$R PUZZLE15.RES}

const DBM_W = 64;
      DBM_H = 64;
      DBM_MW = 4;
      DBM_MH = 4;

      GWL_WINSTATE = 0;
      GWL_HIDDENPARENT = 4;
      GWL_MAINPARENT = 8;

{

  This message is sent from figure to parent window

  WPARAM = number of clicked figure
  LPARAM = 0

}

const WM_FIGCLICKED = WM_USER+1;

{

  This message is used to redraw figure

  No parameters

}

const WM_REDRAWFIG = WM_USER+2;

{ This message used to toggle window placement

  WP = 0 - window shows itself in taskbar
  WP = 1 - window shows itself as system tray icon
}

const WM_INTOTRAY = WM_USER+3;

{ This message is standard callback message from systray icon }

const WM_TRAYCB = WM_USER+4;

{ This message used to recalculate game layout }

const WM_CHANGELAYOUT = WM_USER+5;

type LayoutArray = array [0..63] of integer;
     P15FigData = record
      BM : HBITMAP;
      HWnd : HWND;
      Number : integer;
     end;
     P15FigDataPtr = ^P15FigData;

var Layout : LayoutArray;
    Instance : THandle;
    ToolTipWnd : HWND;
    VI : TOSVersionInfo;
    InTray : boolean;
    LayoutWidth : integer;
    Bitmaps : array [0..63] of HBITMAP;
    Figures : array [0..63] of P15FigData;

{ Figure bitmaps synthesis }

const SgmWidth = 11;
      SgmHeight = 13;

procedure DrawLine (DC : HDC;X,Y,L : integer;Color : TColorRef;Vertical : boolean);
 var OldPen,ThePen : HPen;
 begin
  ThePen:=CreatePen (PS_SOLID,1,Color);
  OldPen:=SelectObject (DC,ThePen);
  MoveToEx (DC,X,Y,NIL);
  if Vertical then LineTo (DC,X,Y+L) else LineTo (DC,X+L,Y);
  SelectObject (DC,OldPen);
  DeleteObject (ThePen);
 end;

procedure DrawSegment (DC : HDC;X,Y : integer;Color : TColorRef;Vertical : boolean);
 begin
  if Vertical then
   begin
    DrawLine (DC,X,Y,SgmHeight,Color,TRUE);
    DrawLine (DC,X+1,Y,SgmHeight,Color,TRUE);
   end
  else
   begin
    DrawLine (DC,X,Y,SgmWidth,Color,FALSE);
    DrawLine (DC,X,Y+1,SgmWidth,Color,FALSE);
   end;
 end;

type SegmentRec = record
      X,Y : integer;
      V : boolean;
     end;

const SegmentLayout : array [0..6] of SegmentRec =
      ((X:2;Y:0;V:FALSE),(X:2+SgmWidth;Y:2;V:TRUE),(X:2+SgmWidth;Y:4+SgmHeight;V:TRUE),
       (X:2;Y:4+2*SgmHeight;V:FALSE),(X:0;Y:4+SgmHeight;V:TRUE),(X:0;Y:2;V:TRUE),
       (X:2;Y:2+SgmHeight;V:FALSE));

      DigitBits : array [0..9] of byte =
      ($3F,$06,$5B,$4F,$66,$6D,$7D,$07,$7F,$6F);

{ Digit constructor }

procedure DrawDigit (DC : HDC;X,Y : integer;Color : TColorRef;Digit : byte);
 var J : integer;
 begin
  for J:=0 to 6 do
   if (DigitBits[Digit] and (1 shl J))<>0 then
    DrawSegment (DC,X+SegmentLayout[J].X,Y+SegmentLayout[J].Y,Color,SegmentLayout[J].V);
 end;

const LDigitX = 15;
      LDigitY = 16;
      RDigitX = 34;
      RDigitY = 16;

{ Puzzle figure constructor }

function CreateFigure (Digit : byte;Back,Border,Dig,Shad : TColorRef) : HBITMAP;
 var MemDC : HDC;
     OldBM,NewBM : HBITMAP;
     NewBr : HBRUSH;
     R : TRect;
 begin
  MemDC:=CreateCompatibleDC (0);
  NewBM:=CreateBitmap (DBM_W,DBM_H,GetDeviceCaps (MemDC,PLANES),GetDeviceCaps (MemDC,BITSPIXEL),NIL);
  OldBM:=SelectObject (MemDC,NewBM);
  if Digit=0 then
   begin
    NewBr:=CreateSolidBrush (0);
    R.Left:=0;
    R.Top:=0;
    R.Right:=64;
    R.Bottom:=64;
    FillRect (MemDC,R,NewBr);
    DeleteObject (NewBr);
   end
  else
   begin
    NewBr:=CreateSolidBrush (Border);
    R.Left:=0;
    R.Top:=0;
    R.Right:=64;
    R.Bottom:=64;
    FillRect (MemDC,R,NewBr);
    DeleteObject (NewBr);
    NewBr:=CreateSolidBrush (Back);
    R.Left:=2;
    R.Top:=2;
    R.Right:=62;
    R.Bottom:=62;
    FillRect (MemDC,R,NewBr);
    DeleteObject (NewBr);
    DrawDigit (MemDC,LDigitX+1,LDigitY+1,Shad,Digit div 10);
    DrawDigit (MemDC,LDigitX,LDigitY,Dig,Digit div 10);
    DrawDigit (MemDC,RDigitX+1,RDigitY+1,Shad,Digit mod 10);
    DrawDigit (MemDC,RDigitX,RDigitY,Dig,Digit mod 10);
   end;
  SelectObject (MemDC,OldBM);
  DeleteDC (MemDC);
  Result:=NewBM;
 end;

{ Hole search support }

function HoleTest (XH,YH : integer;var HNum : integer) : boolean;
 var H : integer;
 begin
  H:=YH*LayoutWidth+XH;
  if Layout[H]=0 then
   begin
    HNum:=H;
    Result:=TRUE;
   end
  else Result:=FALSE;
 end;

{

  Hole searching

  If a hole found nearby (right,left,up or down) returns TRUE,
  and places a number of hole to HoleNum.
  Otherwise returns FALSE, and HoleNum remains unchanged.

}

function IsHoleNear (FigNum : integer;var HoleNum : integer) : boolean;
 var VFlags : array [0..3] of boolean;
     Res : boolean;
     FigX,FigY : integer;
 begin
  if Layout[FigNum]=0 then { Preventing stupid calculations }
   begin
    Result:=FALSE;
    Exit;
   end;
  FigX:=FigNum mod LayoutWidth;
  FigY:=FigNum div LayoutWidth;
  VFlags[0]:=(FigX>0);             { left direction flag }
  VFlags[1]:=(FigX<LayoutWidth-1); { right direction flag }
  VFlags[2]:=(FigY>0);             { up direction flag }
  VFlags[3]:=(FigY<LayoutWidth-1); { down direction flag }
  Res:=FALSE;
  if VFlags[0] then Res:=Res or HoleTest (FigX-1,FigY,HoleNum);
  if VFlags[1] and (not Res) then Res:=Res or HoleTest (FigX+1,FigY,HoleNum);
  if VFlags[2] and (not Res) then Res:=Res or HoleTest (FigX,FigY-1,HoleNum);
  if VFlags[3] and (not Res) then Res:=Res or HoleTest (FigX,FigY+1,HoleNum);
  Result:=Res;
 end;

{ Shuffle }

procedure SwapInts (var A,B : integer);
 var Tmp : integer;
 begin
  Tmp:=A;
  A:=B;
  B:=Tmp;
 end;

procedure ShuffleFigures;
 var VFlags : array [0..3] of boolean;
     Vectors : array [0..3] of integer;
     HoleX,HoleY : integer;
     J,K,L,M : integer;
 begin
  M:=LayoutWidth*LayoutWidth;
  for J:=0 to M-2 do Layout[J]:=J+1;  { initial eq final }
  Layout[M-1]:=0;
  HoleX:=LayoutWidth-1;                    { down-right corner }
  HoleY:=HoleX;
  for J:=256*M downto 1 do
   begin
    VFlags[0]:=(HoleX>0);                  { move left flag }
    VFlags[1]:=(HoleX<LayoutWidth-1);      { move right flag }
    VFlags[2]:=(HoleY>0);                  { move up flag }
    VFlags[3]:=(HoleY<LayoutWidth-1);      { move down flag }
    L:=0;
    for K:=0 to 3 do           { prepare shuffle vectors }
     begin
      if VFlags[K] then
       begin
        Vectors[L]:=K;
        Inc (L);
       end;
     end;
    case Vectors[Random (L)] of            { shuffle }
     0:
      begin                                { moving left }
       SwapInts (Layout[HoleY*LayoutWidth+HoleX],Layout[HoleY*LayoutWidth+HoleX-1]);
       Dec (HoleX);
      end;
     1:
      begin                                { moving right }
       SwapInts (Layout[HoleY*LayoutWidth+HoleX],Layout[HoleY*LayoutWidth+HoleX+1]);
       Inc (HoleX);
      end;
     2:
      begin                                { moving up }
       SwapInts (Layout[HoleY*LayoutWidth+HoleX],Layout[(HoleY-1)*LayoutWidth+HoleX]);
       Dec (HoleY);
      end;
     3:
      begin                                { moving down }
       SwapInts (Layout[HoleY*LayoutWidth+HoleX],Layout[(HoleY+1)*LayoutWidth+HoleX]);
       Inc (HoleY);
      end;
    end;
   end;         { there must be well shuffled (but collectable) layout }
 end;

{ Game over status testing }

function IsGameOver : boolean;
 var J,K : integer;
     B : boolean;
 begin
  B:=TRUE;
  K:=LayoutWidth*LayoutWidth;
  for J:=0 to K-2 do
   begin
    B:=B and (Layout[J]=J+1);
    if not B then Break;
   end;
  if B then B:=B and (Layout[K-1]=0);
  Result:=B;
 end;

{ P15FIG class }

function P15Fig_WProc (Wnd : HWND;Msg,WP,LP : DWORD) : DWORD; stdcall; export;
 const ToolText : array [1..3] of PChar =
       ('Click it!','It''s a hole.','You can''t move it.');
 type PNmhdr = ^TNmhdr;
 var P : TPaintStruct;
     OldBM : HBITMAP;
     DC : HDC;
     D : P15FigDataPtr;
     Wr : TRect;
     TTT : PToolTipText;
     J : integer;
 begin
  D:=P15FigDataPtr (GetWindowLong (Wnd,0));
  Result:=0;
  case Msg of
   WM_PAINT:
    begin
     BeginPaint (Wnd,P);
     DC:=CreateCompatibleDC (P.hdc);
     OldBM:=SelectObject (DC,D^.BM);
     BitBlt (P.hdc,0,0,DBM_W,DBM_H,DC,0,0,SRCCOPY);
     SelectObject (DC,OldBM);
     DeleteDC (DC);
     EndPaint (Wnd,P);
    end;
   WM_LBUTTONDOWN: SendMessage (GetParent (Wnd),WM_FIGCLICKED,D^.Number,0);
   WM_REDRAWFIG:
    begin
     GetClientRect (Wnd,Wr);
     InvalidateRect (Wnd,@Wr,FALSE);
     UpdateWindow (Wnd);
    end;
   WM_NOTIFY:
    case PNmhdr (LP)^.Code of
     TTN_NEEDTEXT:
      begin
       TTT:=PToolTipText (LP);
       TTT^.hInst:=0;
       if IsHoleNear (D^.Number,J) then J:=1
       else if Layout[D^.Number]=0 then J:=2
       else J:=3;
       TTT^.lpszText:=ToolText[J];
      end;
     end;
   else Result:=DefWindowProc (Wnd,Msg,WP,LP);
  end;
 end;

function InitClass_P15Fig : boolean;
 var W : TWndClassEx;
 begin
  ZeroMemory (@W,SizeOf (W));
  with W do
   begin
    cbSize:=SizeOf (W);
    style:=CS_HREDRAW+CS_VREDRAW+CS_PARENTDC;
    lpfnWndProc:=TFNWndProc (@P15Fig_WProc);
    cbWndExtra:=SizeOf (P15FigDataPtr);
    hInstance:=Instance;
    hCursor:=LoadCursor (0,PChar (IDC_ARROW));
    hbrBackground:=GetStockObject (BLACK_BRUSH);
    lpszClassName:='P15FIG';
   end;
  Result:=(RegisterClassEx (W)<>0);
 end;

{ P15HIDDEN class }

function P15Hidden_WProc (Wnd : HWND;Msg,WP,LP : DWORD) : DWORD; stdcall;
 begin
  Result:=DefWindowProc (Wnd,Msg,WP,LP);
 end;

function InitClass_P15Hidden : boolean;
 var W : TWndClassEx;
 begin
  ZeroMemory (@W,SizeOf (W));
  with W do
   begin
    cbSize:=SizeOf (W);
    style:=CS_HREDRAW+CS_VREDRAW;
    lpfnWndProc:=TFNWndProc (@P15Hidden_WProc);
    hInstance:=Instance;
    hIcon:=LoadIcon (Instance,PChar (ID_MAINICON));
    hCursor:=LoadCursor (0,PChar (IDC_ARROW));
    hbrBackground:=GetStockObject (BLACK_BRUSH);
    lpszMenuName:=PChar (ID_MAINMENU);
    lpszClassName:='P15HIDDEN';
   end;
  Result:=(RegisterClassEx (W)<>0);
 end;

{ P15MAIN class (main window) }

const WinTitle = 'Puzzle 15';

var GameOver : boolean;
    HiddenWin,MainWin,DesktopWnd : HWND;
    NID : TNotifyIconData;
    TrayPopupMenu : HMENU;

function InstructionBox_WProc (Dlg : HWND;Msg,WP,LP : DWORD) : longbool; stdcall; export;
 var Wr : TRect;
     L,H : integer;
 begin
  case Msg of
   WM_INITDIALOG:
    begin
     Wr.Left:=0;
     Wr.Top:=0;
     Wr.Right:=350;
     Wr.Bottom:=192;
     L:=Wr.Right-Wr.Left;
     H:=Wr.Bottom-Wr.Top;
     AdjustWindowRect (Wr,WS_POPUP+WS_CAPTION+WS_SYSMENU+DS_MODALFRAME,FALSE);
     SetWindowPos (Dlg,0,
                   (GetSystemMetrics (SM_CXSCREEN)-Wr.Right+Wr.Left) shr 1,
                   (GetSystemMetrics (SM_CYSCREEN)-Wr.Bottom+Wr.Top) shr 1,
                   L,H,SWP_NOZORDER);
     GetClientRect (Dlg,Wr);
     L:=Wr.Right-Wr.Left;
     H:=Wr.Bottom-Wr.Top;
     SetWindowPos (GetDlgItem (Dlg,100),0,8,0,L-16,104,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,101),0,16,16,L-32,16,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,102),0,16,32,L-32,16,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,103),0,16,48,L-32,16,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,104),0,16,64,L-32,16,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,105),0,16,80,L-32,16,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,106),0,(L-96) shr 1,96+((H-120) shr 1),96,32,SWP_NOZORDER);
     SetFocus (GetDlgItem (Dlg,106));
     Result:=TRUE;
     Exit;
    end;
   WM_COMMAND:
    begin
     if (WP=106) or (WP=IDCANCEL) then
      begin
       EndDialog (Dlg,0);
       Result:=TRUE;
       Exit;
      end;
    end;
  end;
  Result:=FALSE;
 end;

function AboutBox_WProc (Dlg : HWND;Msg,WP,LP : DWORD) : longbool; stdcall; export;
 var Wr : TRect;
     XI,YI : integer;
 begin
  case Msg of
   WM_INITDIALOG:
    begin
     Wr.Left:=0;
     Wr.Top:=0;
     Wr.Right:=300;
     Wr.Bottom:=190;
     SetWindowPos (Dlg,0,
                   (GetSystemMetrics (SM_CXSCREEN)-Wr.Right+Wr.Left) shr 1,
                   (GetSystemMetrics (SM_CYSCREEN)-Wr.Bottom+Wr.Top) shr 1,
                   Wr.Right-Wr.Left,Wr.Bottom-Wr.Top,SWP_NOZORDER);
     GetClientRect (Dlg,Wr);
     SetWindowPos (GetDlgItem (Dlg,100),0,8,0,Wr.Right-16,Wr.Bottom-48,SWP_NOZORDER);
     XI:=GetSystemMetrics (SM_CXICON);
     YI:=GetSystemMetrics (SM_CYICON);
     SetWindowPos (GetDlgItem (Dlg,101),0,24,24,XI,YI,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,102),0,48+XI,16+((YI-16) shr 1),Wr.Right-64-XI,16,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,103),0,48+XI,32+((YI-16) shr 1),Wr.Right-64-XI,16,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,104),0,24,YI+48,Wr.Right-48,16,SWP_NOZORDER);
     SetWindowPos (GetDlgItem (Dlg,105),0,(Wr.Right-96) shr 1,Wr.Bottom-40,96,32,SWP_NOZORDER);
     SetFocus (GetDlgItem (Dlg,104));
     Result:=TRUE;
     Exit;
    end;
   WM_COMMAND:
    if (WP=105) or (WP=IDCANCEL) then
     begin
      EndDialog (Dlg,0);
      Result:=TRUE;
      Exit;
     end;
  end;
  Result:=FALSE;
 end;

function P15Main_WProc (Wnd : HWND;Msg,WP,LP : DWORD) : DWORD; stdcall; export;
 var Wr : TRect;
     HNum,INum,T,X,Y : integer;
     HB : HBITMAP;
     P : TPoint;
     Fig : HWnd;
     TI : TToolInfo;
 begin
  Result:=0;
  case Msg of
{  WM_CREATE:
    begin
     GetClientRect (Wnd,Wr);
     SetWindowPos (Wnd,0,
		   (GetSystemMetrics (SM_CXSCREEN)-Wr.Right+Wr.Left) shr 1,
		   (GetSystemMetrics (SM_CYSCREEN)-Wr.Bottom+Wr.Top) shr 1,
		   0,0,SWP_NOSIZE+SWP_NOZORDER);
    end;}
   WM_DESTROY:
    begin
     if InTray then Shell_NotifyIcon (NIM_DELETE,@NID);
     PostQuitMessage (0);
    end;
   WM_TRAYCB:
    begin
     if LP=WM_LBUTTONDOWN then
      begin
       ShowWindow (Wnd,SW_SHOWNORMAL);
       SetForegroundWindow (Wnd);
      end
     else
      if LP=WM_RBUTTONDOWN then
       begin
        if IsWindowVisible (Wnd) then
         begin
          ShowWindow (Wnd,SW_SHOWNORMAL);
          SetForegroundWindow (Wnd);
         end
        else
         begin
          GetCursorPos (P);
          TrackPopupMenu (TrayPopupMenu,TPM_LEFTBUTTON,P.X,P.Y,0,Wnd,NIL);
         end;
       end;
    end;
   WM_SYSCOMMAND:
    begin
     if InTray and ((WP and $FFF0)=SC_MINIMIZE) then ShowWindow (Wnd,SW_HIDE)
     else Result:=DefWindowProc (Wnd,Msg,WP,LP);
    end;
   WM_CHANGELAYOUT:
    begin
     if IsWindowVisible (Wnd) then ShowWindow (Wnd,SW_HIDE);
     if LayoutWidth<>0 then
      begin
       HNum:=LayoutWidth*LayoutWidth;
       for T:=0 to HNum-1 do
        begin
         DestroyWindow (Figures[T].HWnd);
         DeleteObject (Bitmaps[T]);
        end;
      end;
     LayoutWidth:=WP;
     CheckMenuRadioItem (GetMenu (Wnd),CM_SKNORMAL,CM_SKMONSTEROFLOGIC,CM_SKNORMAL+WP-4,MF_BYCOMMAND);
     Wr.Left:=0;
     Wr.Top:=0;
     Wr.Right:=DBM_W*LayoutWidth+DBM_MW*(LayoutWidth+1);
     Wr.Bottom:=DBM_H*LayoutWidth+DBM_MH*(LayoutWidth+1);
     AdjustWindowRect (Wr,GetWindowLong (Wnd,GWL_STYLE),TRUE);
     SetWindowPos (Wnd,0,
		   (GetSystemMetrics (SM_CXSCREEN)-Wr.Right+Wr.Left) shr 1,
		   (GetSystemMetrics (SM_CYSCREEN)-Wr.Bottom+Wr.Top) shr 1,
		   Wr.Right-Wr.Left,Wr.Bottom-Wr.Top,SWP_NOZORDER);
     if ToolTipWnd<>0 then DestroyWindow (ToolTipWnd);
     ToolTipWnd:=CreateWindowEx (0,TOOLTIPS_CLASS,'',0,CW_USEDEFAULT,CW_USEDEFAULT,
                                 CW_USEDEFAULT,CW_USEDEFAULT,MainWin,0,Instance,NIL);
     HNum:=LayoutWidth*LayoutWidth;
     for T:=0 to HNum-1 do
      begin
       Bitmaps[T]:=CreateFigure (T,$FFFF00,$0000FF,$FF0000,$000000);
       X:=(T mod LayoutWidth)*(DBM_W+DBM_MW)+DBM_MW;
       Y:=(T div LayoutWidth)*(DBM_H+DBM_MH)+DBM_MH;
       Figures[T].BM:=Bitmaps[0];
       Figures[T].Number:=T;
       Fig:=CreateWindowEx (0,'P15FIG','',WS_CHILD+WS_CLIPSIBLINGS,X,Y,DBM_W,DBM_H,
                            MainWin,T,Instance,NIL);
       Figures[T].HWnd:=Fig;
       SetWindowLong (Fig,0,DWORD (@Figures[T]));
       ShowWindow (Fig,SW_SHOWNORMAL);
       ZeroMemory (@TI,SizeOf (TI));
       with TI do
        begin
         cbSize:=SizeOf (TI);
         uFlags:=TTF_SUBCLASS;
         hWnd:=Fig;
         uId:=T;
         rect.Left:=0;
         rect.Top:=0;
         rect.Right:=DBM_W;
         rect.Bottom:=DBM_H;
         hInst:=0;
         lpszText:=LPSTR_TEXTCALLBACK;
        end;
       SendMessage (ToolTipWnd,TTM_ADDTOOL,0,DWORD (@TI));
      end;
     SendMessage (ToolTipWnd,TTM_SETDELAYTIME,TTDT_INITIAL,2500);
     SendMessage (ToolTipWnd,TTM_SETDELAYTIME,TTDT_RESHOW,2500);
     SendMessage (ToolTipWnd,TTM_SETDELAYTIME,TTDT_AUTOPOP,2500);
     SendMessage (Wnd,WM_COMMAND,CM_NEWGAME,0);
     if not IsWindowVisible (Wnd) then ShowWindow (Wnd,SW_SHOWNORMAL);
    end;
   WM_COMMAND:
    begin
     if LP=0 then
      begin
       case LoWord (WP) of
        CM_NEWGAME:
         begin
          ShuffleFigures;
          HNum:=LayoutWidth*LayoutWidth;
          for T:=0 to HNum-1 do
           begin
            Figures[T].BM:=Bitmaps[Layout[T]];
            SendMessage (Figures[T].hWnd,WM_REDRAWFIG,0,0);
           end;
          GameOver:=FALSE;
         end;
        CM_EXIT: SendMessage (Wnd,WM_DESTROY,0,0);
        CM_INSTRUCTION: DialogBox (Instance,PChar (ID_INSTRUCTIONBOX),Wnd,MakeProcInstance (@InstructionBox_WProc,Instance));
        CM_ABOUT: DialogBox (Instance,PChar (ID_ABOUTBOX),Wnd,MakeProcInstance (@AboutBox_WProc,Instance));
        CM_SKNORMAL..CM_SKMONSTEROFLOGIC: SendMessage (Wnd,WM_CHANGELAYOUT,LoWord (WP)-CM_SKNORMAL+4,0);
        CM_INTOTRAY:
         begin
          T:=GetWindowLong (Wnd,GWL_WINSTATE);
          SetWindowLong (Wnd,GWL_WINSTATE,T xor 1);
          InTray:=not InTray;
          if InTray then
           begin
            SetWindowLong (Wnd,GWL_HWNDPARENT,GetWindowLong (Wnd,GWL_HIDDENPARENT));
            CheckMenuItem (GetMenu (Wnd),CM_INTOTRAY,MF_BYCOMMAND+MF_CHECKED);
            Shell_NotifyIcon (NIM_ADD,@NID);
           end
          else
           begin
            SetWindowLong (Wnd,GWL_HWNDPARENT,GetWindowLong (Wnd,GWL_MAINPARENT));
            CheckMenuItem (GetMenu (Wnd),CM_INTOTRAY,MF_BYCOMMAND+MF_UNCHECKED);
            Shell_NotifyIcon (NIM_DELETE,@NID);
            ShowWindow (HiddenWin,SW_SHOW);  { a taskbar updating trick }
            ShowWindow (HiddenWin,SW_HIDE);
           end;
         end;
        CM_RESTORE:
         begin
          ShowWindow (Wnd,SW_SHOWNORMAL);
          SetForegroundWindow (Wnd);
         end;
       end;
      end;
    end;
   WM_FIGCLICKED:
    begin
     INum:=WP;
     if (not GameOver) and IsHoleNear (INum,HNum) then
      begin
       HB:=Figures[INum].BM;
       Figures[INum].BM:=Figures[HNum].BM;
       SendMessage (Figures[INum].hWnd,WM_REDRAWFIG,0,0);
       Figures[HNum].BM:=HB;
       SendMessage (Figures[HNum].hWnd,WM_REDRAWFIG,0,0);
       T:=Layout[INum];
       Layout[INum]:=Layout[HNum];
       Layout[HNum]:=T;
       GameOver:=IsGameOver;
       if GameOver then MessageBox (Wnd,'You made it!','Victory',MB_OK+MB_ICONINFORMATION);
      end
     else MessageBeep (0);
    end;
   else Result:=DefWindowProc (Wnd,Msg,WP,LP);
  end;
 end;

function InitClass_P15Main : boolean;
 var W : TWndClassEx;
 begin
  ZeroMemory (@W,SizeOf (W));
  with W do
   begin
    cbSize:=SizeOf (W);
    cbWndExtra:=12;
    style:=CS_HREDRAW+CS_VREDRAW;
    lpfnWndProc:=TFNWndProc (@P15Main_WProc);
    hInstance:=Instance;
    hIcon:=LoadIcon (Instance,PChar (ID_MAINICON));
    hIconSm:=LoadImage (Instance,PChar (ID_MAINICONSM),IMAGE_ICON,
                        GetSystemMetrics (SM_CXSMICON),
                        GetSystemMetrics (SM_CYSMICON),0);
    hCursor:=LoadCursor (0,PChar (IDC_ARROW));
    hbrBackground:=GetStockObject (BLACK_BRUSH);
    lpszMenuName:=PChar (ID_MAINMENU);
    lpszClassName:='P15MAIN';
   end;
  Result:=(RegisterClassEx (W)<>0);
 end;

procedure Problem (AText : PChar);
 begin
  MessageBox (DesktopWnd,AText,WinTitle,MB_OK+MB_ICONINFORMATION);
 end;

procedure Main;
 label Quit,SaveProblem,SaveProblem1;
 var Msg : TMsg;
     HAccel : THandle;
     J,K : integer;
     SysMenu,TPMenu : HMenu;
     RH : THandle;
     Dsp : integer;
     KeyVal : array [0..10] of char;
 begin
  DesktopWnd:=GetDesktopWindow;
  Instance:=GetModuleHandle (NIL);
  ZeroMemory (@VI,SizeOf (VI));
  VI.dwOSVersionInfoSize:=SizeOf (VI);
  GetVersionEx (VI);
  if (VI.dwMajorVersion<4) and (VI.dwPlatformID=VER_PLATFORM_WIN32_NT) then
   begin
    Problem ('Sorry, this game runs under Win32 4.x or greater.');
    Exit;
   end;
  MainWin:=FindWindow ('P15MAIN',NIL);
  if MainWin<>0 then
   begin
    if IsIconic (MainWin) then ShowWindow (MainWin,SW_RESTORE);
    SetForegroundWindow (MainWin);
    Exit;
   end;
  Randomize;
  InTray:=FALSE;
  if RegCreateKeyEx (HKEY_LOCAL_MACHINE,'Software\Mr.Konnov\Puzzle15',0,NIL,
                     REG_OPTION_NON_VOLATILE,KEY_READ,NIL,HKey (RH),PDWORD (@Dsp))<>ERROR_SUCCESS then
   begin
    Problem ('Can''t read settings.');
    Exit;
   end;
  ZeroMemory (@KeyVal,SizeOf (KeyVal));
  J:=REG_SZ;
  K:=10;
  RegQueryValueEx (RH,'InTray',NIL,@J,@KeyVal,@K);
  if KeyVal[0]='1' then InTray:=TRUE;
  ZeroMemory (@KeyVal,SizeOf (KeyVal));
  J:=REG_SZ;
  K:=10;
  RegQueryValueEx (RH,'SkillLevel',NIL,@J,@KeyVal,@K);
  K:=4;
  if (KeyVal[0]<>#0) and (KeyVal[0] in ['0'..'4']) then K:=Ord (KeyVal[0])-Ord ('0')+4;
  RegCloseKey (RH);
  if not InitClass_P15Hidden then
   begin
    Problem ('Can''t register hidden window class.');
    Exit;
   end;
  if not InitClass_P15Main then
   begin
    Problem ('Can''t register main window class.');
    Exit;
   end;
  HAccel:=LoadAccelerators (Instance,PChar (ID_MAINMENU));
  TPMenu:=LoadMenu (Instance,PChar (ID_TRAYPOPUP));
  TrayPopupMenu:=GetSubMenu (TPMenu,0);
  if not InitClass_P15Fig then
   begin
    Problem ('Can''t register figure class.');
    Exit;
   end;
  ZeroMemory (@Figures,SizeOf (Figures));
  ZeroMemory (@Bitmaps,SizeOf (Bitmaps));
  ToolTipWnd:=0;
  HiddenWin:=CreateWindowEx (0,'P15HIDDEN',WinTitle,0,-8192,-8192,1,1,0,0,Instance,NIL);
  MainWin:=CreateWindowEx (0,'P15MAIN',WinTitle,WS_OVERLAPPED+WS_SYSMENU+WS_MINIMIZEBOX,
                           0,0,1,1,0,0,Instance,NIL);
  if MainWin=0 then
   begin
    Problem ('Can''t create main window.');
    Exit;
   end;
  SetWindowLong (MainWin,GWL_WINSTATE,0);
  SetWindowLong (MainWin,GWL_HIDDENPARENT,HiddenWin);
  SetWindowLong (MainWin,GWL_MAINPARENT,GetParent (MainWin));
  with NID do
   begin
    cbSize:=SizeOf (NID);
    Wnd:=MainWin;
    uID:=100;
    uFlags:=NIF_ICON+NIF_MESSAGE+NIF_TIP;
    uCallbackMessage:=WM_TRAYCB;
    HIcon:=LoadImage (Instance,PChar (ID_MAINICONSM),IMAGE_ICON,0,0,0);
    szTip:=WinTitle;
   end;
  InitCommonControls;
  SendMessage (MainWin,WM_CHANGELAYOUT,K,0);
  SysMenu:=GetSystemMenu (MainWin,FALSE);
  DeleteMenu (SysMenu,SC_ZOOM,MF_BYCOMMAND);
  DeleteMenu (SysMenu,SC_SIZE,MF_BYCOMMAND);
  DrawMenuBar (SysMenu);
  if InTray then
   begin
    InTray:=FALSE;
    SendMessage (MainWin,WM_COMMAND,CM_INTOTRAY,0);
   end;
  if InTray and (System.CmdShow=SW_SHOWMINIMIZED) then System.CmdShow:=SW_HIDE;
  ShowWindow (MainWin,System.CmdShow);
  while GetMessage (Msg,0,0,0) do                        { bug was HERE! }
   begin
    if TranslateAccelerator (MainWin,HAccel,Msg)=0 then
     begin
      TranslateMessage (Msg);
      DispatchMessage (Msg);
     end;
   end;
  DestroyMenu (TPMenu);
  if RegCreateKeyEx (HKEY_LOCAL_MACHINE,'Software\Mr.Konnov\Puzzle15',0,NIL,
                     REG_OPTION_NON_VOLATILE,KEY_WRITE,NIL,RH,@Dsp)<>ERROR_SUCCESS then
   begin
    SaveProblem:
    Problem ('Can''t save settings.');
    goto Quit;
   end;
  ZeroMemory (@KeyVal,SizeOf (KeyVal));
  if InTray then KeyVal[0]:='1' else KeyVal:='0';
  Dsp:=RegSetValueEx (RH,'InTray',0,REG_SZ,@KeyVal,2);
  if Dsp<>ERROR_SUCCESS then
   begin
    SaveProblem1:
    RegCloseKey (RH);
    goto SaveProblem;
   end;
  ZeroMemory (@KeyVal,SizeOf (KeyVal));
  KeyVal[0]:=Chr (Ord ('0')+LayoutWidth-4);
  Dsp:=RegSetValueEx (RH,'SkillLevel',0,REG_SZ,@KeyVal,2);
  if Dsp<>ERROR_SUCCESS then goto SaveProblem1;
  RegCloseKey (RH);
  Quit:;
  DestroyWindow (MainWin);
  DestroyWindow (HiddenWin);
  DestroyWindow (ToolTipWnd);
  K:=LayoutWidth*LayoutWidth;
  for J:=0 to K-1 do DeleteObject (Bitmaps[J]);
 end;

begin
 Main;
end.
